// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'ngCordova', 'starter.controllers', 'starter.services', 'starter.directives'])

.run(function($ionicPlatform) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins.Keyboard) {
      //cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }

    if (typeof analytics !== 'undefined'){
      console.log("loading google analytics")
      analytics.startTrackerWithId('UA-56732427-2');
      analytics.trackView('app-load');
    }

  });
})



.run(['$rootScope',function($rootScope){ 

    // Credits: Adam's answer in http://stackoverflow.com/a/20786262/69362
    // Paste this in browser's console
    //var $rootScope = angular.element(document.querySelectorAll("[ui-view]")[0]).injector().get('$rootScope');
     
    //$rootScope.$on('$stateChangeStart',function(event, toState, toParams, fromState, fromParams){
    //  console.log('$stateChangeStart to '+toState.name+'- fired when the transition begins. toState,toParams : \n',toState, toParams);
    //});
     
    //$rootScope.$on('$stateChangeError',function(event, toState, toParams, fromState, fromParams){
    //  console.log('$stateChangeError - fired when an error occurs during transition.');
    //  console.log(arguments);
    //});
     
    $rootScope.$on('$stateChangeSuccess',function(event, toState, toParams, fromState, fromParams){
      console.log('$stateChangeSuccess to '+toState.name+'- fired once the state transition is complete.');

      if (typeof analytics !== 'undefined') {
          console.log("logging state change in Google Analytics")

          analytics.trackView(toState.name);      
      }

    });
     
    //$rootScope.$on('$viewContentLoaded',function(event){
    //  console.log('$viewContentLoaded - fired after dom rendered',event);
    //});
     
    //$rootScope.$on('$stateNotFound',function(event, unfoundState, fromState, fromParams){
    //  console.log('$stateNotFound '+unfoundState.to+'  - fired when a state cannot be found by its name.');
    //  console.log(unfoundState, fromState, fromParams);
    //});

}])


.filter('rawHtml', ['$sce', function($sce){
  return function(val) {
    return $sce.trustAsHtml(val);
  };
}])

/*

.filter('getByProperty', function() {
    return function(propertyName, propertyValue, collection) {
        var i=0, len=collection.length;
        for (; i<len; i++) {
            if (collection[i][propertyName] == +propertyValue) {
                return collection[i];
            }
        }
        return null;
    }
});

*/

.config(function($ionicConfigProvider) {
    $ionicConfigProvider.views.transition('none');
})

.config(function($compileProvider){
  $compileProvider.imgSrcSanitizationWhitelist(/^\s*(https?|ftp|mailto|file|tel):/);
})

.config(function($stateProvider, $urlRouterProvider) {

  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
  $stateProvider

  // setup an abstract state for the tabs directive
  .state('tab', {
    url: "/tab",
    abstract: true,
    templateUrl: "templates/app.html",
    contoller: 'AppController'
  })

  .state('tab.home', {
    url: '/home',
    views: {
      'view-content': {
        templateUrl: 'templates/home.html',
        controller: 'HomeController'
      }
    }
  })

  .state('tab.about', {
    url: '/about',
    views: {
      'view-content': {
        templateUrl: 'templates/about.html',
        controller: 'AboutController'
      }
    }
  })

  .state('tab.search', {
    url: '/search',
    views: {
      'view-content': {
        templateUrl: 'templates/search.html',
        controller: 'SearchController'
      }
    }
  })

  .state('tab.searching', {
    url: '/searching',
    views: {
      'view-content': {
        templateUrl: 'templates/searching.html',
        controller: 'SearchingController'
      }
    }
  })

  .state('tab.list', {
      url: '/list',
      views: {
          'view-content': {
          templateUrl: 'templates/list.html',
          controller: 'ListCtrl'
        }
      }
    })

  .state('tab.map', {
      url: '/map',
      views: {
          'view-content': {
          templateUrl: 'templates/map.html',
          controller: 'MapCtrl'
        }
      }
    })
  .state('tab.entry', {
      url: '/entry/:entryId',
      views: {
        'view-content': {
          templateUrl: 'templates/entry.html',
          controller: 'EntryController'
        }
      }
    })
  .state('tab.submit', {
      url: '/submit',
      views: {
        'view-content': {
          templateUrl: 'templates/submit.html',
          controller: 'SubmitEntryController'
        }
      }
    })
  .state('tab.edit', {
      url: '/edit/:entryId',
      views: {
        'view-content': {
          templateUrl: 'templates/edit.html',
          controller: 'EntryEditController'
        }
      }
    })
  .state('tab.addphoto', {
      url: '/addphoto/:entryId',
      views: {
        'view-content': {
          templateUrl: 'templates/addphoto.html',
          controller: 'EntryAddPhotoController'
        }
      }
    })

  .state('tab.profile', {
    url: '/profile',
    views: {
      'view-content': {
        templateUrl: 'templates/profile.html',
        controller: 'AccountController'
      }
    }
  })
  .state('tab.account', {
    url: '/account',
    views: {
      'view-content': {
        templateUrl: 'templates/account.html',
        controller: 'AccountController'
      }
    }
  })

  .state('tab.supporters', {
    url: '/supporters',
    views: {
      'view-content': {
        templateUrl: 'templates/supporters.html',
        controller: 'SupportersController'
      }
    }
  })
  .state('tab.classroom', {
    url: '/classroom',
    views: {
      'view-content': {
        templateUrl: 'templates/classroom.html',
        controller: 'ClassroomController'
      }
    }
  })
  .state('tab.faq', {
    url: '/faq',
    views: {
      'view-content': {
        templateUrl: 'templates/faq.html',
        controller: 'FaqController'
      }
    }
  })

/*
 tab.support
 /

  /*
  .state('tab.account-institution', {
    url: '/account-institution',
    views: {
      'view-content': {
        templateUrl: 'templates/account-institution.html',
        controller: 'AccountController'
      }
    }
  })
  .state('tab.account-classroom', {
    url: '/account-classroom',
    views: {
      'view-content': {
        templateUrl: 'templates/account-classroom.html',
        controller: 'AccountController'
      }
    }
  })
*/

  ;

  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/tab/home');

});
